---
# Please keep alphabetic order
env:
  node: true
extends:
  - eslint:recommended
  - prettier
  - plugin:prettier/recommended
  - plugin:@typescript-eslint/recommended
  - plugin:security/recommended
  - plugin:import/recommended
  - plugin:import/typescript
parser: '@typescript-eslint/parser'
plugins:
  - '@typescript-eslint'
  - unused-imports
  - import
  - filenames
  - security
root: true
rules:
  '@typescript-eslint/explicit-module-boundary-types':
    - error
  '@typescript-eslint/naming-convention':
    - warn
    - format:
        - camelCase
      leadingUnderscore: allow
      selector: variableLike
    - format:
        - camelCase
        - UPPER_CASE
      modifiers:
        - const
      selector: variable
    - custom:
        match: false
        regex: ^(I[A-Z]|_I[A-Z])
      format:
        - PascalCase
      selector: interface
    - format:
        - PascalCase
      selector: typeLike
  camelcase: 'off'
  comma-dangle:
    - error
    - arrays: always-multiline
      exports: always-multiline
      functions: always-multiline
      imports: always-multiline
      objects: always-multiline
  comma-spacing: error
  complexity:
    - error
    - 12
  eol-last: error
  filenames/match-regex:
    - 2
    - ^([a-zA-Z.][a-z0-9.]*)(-[a-z0-9.]+)*|^[a-z]{2}-[A-Z]{2}$
    - false
  import/no-deprecated: warn
  import/no-extraneous-dependencies: error
  import/order:
    - error
  indent: 'off'
  keyword-spacing: error
  max-len:
    - warn
    - code: 160
  no-async-promise-executor: 'off'
  no-case-declarations: 'off'
  no-dupe-class-members: 'off'
  no-duplicate-imports:
    - error
    - includeExports: true
  no-multiple-empty-lines:
    - error
    - max: 1
  no-trailing-spaces: error
  no-unused-vars: 'off'
  no-use-before-define: 'off'
  object-curly-spacing:
    - error
    - always
  object-property-newline:
    - error
    - allowAllPropertiesOnSameLine: true
  prefer-const: error
  prettier/prettier: error
  quotes:
    - 2
    - single
    - allowTemplateLiterals: true
  security/detect-new-buffer: error
  security/detect-unsafe-regex: error
  semi:
    - error
    - never
  unused-imports/no-unused-imports: error
  unused-imports/no-unused-vars: error
settings:
  import/resolver:
    node:
      extensions:
        - .js
        - .jsx
        - .ts
        - .tsx
      moduleDirectory:
        - node_modules
      paths:
        - /usr/local/share/global_modules
